<?php

declare(strict_types=1);
/**
 * This file is part of Hyperf.
 *
 * @link     https://www.hyperf.io
 * @document https://hyperf.wiki
 * @contact  group@hyperf.io
 * @license  https://github.com/hyperf/hyperf/blob/master/LICENSE
 */
namespace App\Constants;

use Hyperf\Constants\AbstractConstants;
use Hyperf\Constants\Annotation\Constants;

#[Constants]
class ResultCode extends AbstractConstants
{
    /**
     * @Message("成功")
     */
    const SUCCESS = 1000;

    /**
     * @Message("错误")
     */
    const DEFAULT_ERROR = 2000;

    /**
     * @Message("Server Error")
     */
    const SERVER_ERROR = 2001;

    /**
     * @Message("message.param_error")
     */
    const SYSTEM_INVALID = 2002;

    /**
     * @Message("Params %s is invalid.")
     */
    const PARAMS_INVALID = 2003;

    /**
     * @Message("message.record_not_exist")
     */
    const RECORD_NOT_FOUND = 2004;

    /**
     * @Message("message.not_logged")
     */
    const UNAUTHORIZED = 2005;

    /**
     * @Message("无权限")
     */
    const FORBIDDEN = 2006;

    /**
     * @Message("message.too_frequent")
     */
    const TOO_FREQUENT = 2007;

    /**
     * @Message("Not Found")
     */
    const NOT_FOUND = 2008;
}
