<?php

declare(strict_types=1);

namespace App\Exception;

use App\Constants\ResultCode;
use Hyperf\Server\Exception\ServerException;
use Throwable;

abstract class BasicException extends ServerException
{
    protected $code = ResultCode::DEFAULT_ERROR;

    public function __construct(string $message = null, Throwable $previous = null)
    {
        if (is_null($message)) {
            $message = ResultCode::getMessage($this->code);
        }

        parent::__construct($message, $this->code, $previous);
    }
}
