<?php

declare(strict_types=1);

namespace App\Helper;

class StringHelper
{
    const ORDER_NO_TYPE_PAY = 'pay';
    const ORDER_NO_TYPE_PAY_SPLIT = 'pay_split';
    const ORDER_NO_TYPE_REFUND= 'refund';
    const ORDER_NO_TYPE_UNBIND_CARD = 'unbind_card';
    const ORDER_NO_TYPE_QUERY_CUSTOMER_INFO = 'query_customer_info';
    const ORDER_NO_TYPE_REQUEST_ID = 'request_id';

    public static function getRandomString($length, $withSpecialChar = false)
    {
        $chars = array(
            'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k',
            'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
            'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
            'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
            'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '0', '1', '2',
            '3', '4', '5', '6', '7', '8', '9'
        );
    
        if($withSpecialChar){
            $chars = array_merge($chars, array(
                '!', '@', '#', '$', '?', '|', '{', '/', ':', ';',
                '%', '^', '&', '*', '(', ')', '-', '_', '[', ']',
                '}', '<', '>', '~', '+', '=', ',', '.'
            ));
        }
    
        $charsLen = count($chars) - 1;
        shuffle($chars);
        
        $password = '';
        for($i=0; $i<$length; $i++){
            $password .= $chars[mt_rand(0, $charsLen)];
        }

        return $password;
    }

    public static function generateOrderNo($type) {
        $now = time();
        $key = RedisKey::getOrderNoKey($type, $now);
        $incrId = Redis::incr($key);
        $incrId = '' . $incrId;
        Redis::expire($key, 5*60);
        $padLength = 6 - strlen($incrId);
        $incrId = str_pad($incrId, $padLength, '0', STR_PAD_LEFT);
        return date('YmdHis', $now) . $incrId;
    }
}