<?php

declare(strict_types=1);

namespace App\Model;

class Order extends Model
{
    public const STATUS_PREPARE = 'PREPARE';
    public const STATUS_INIT = 'INIT';
    public const STATUS_PROCESS = 'PROCESS';
    public const STATUS_SUCCESS = 'SUCCESS';
    public const STATUS_FAILED = 'FAILED';

    protected $table = 'orders';

    protected $casts = [
        'org_split_info_list' => 'array',
    ];

    public function getExpiresIn() {
        return strtotime($this->expired_at) - time();
    }
}