<?php

declare(strict_types=1);

namespace App\Model;

class Refund extends Model
{
    public const STATUS_PREPARE = 'PREPARE';
    public const STATUS_INIT = 'INIT';
    public const STATUS_PROCESS = 'PROCESS';
    public const STATUS_SUCCESS = 'SUCCESS';
    public const STATUS_FAILED = 'FAILED';

    protected $table = 'refunds';

    public static $shortStatusAndStatusMap = [
        'I' => self::STATUS_INIT,
        'P' => self::STATUS_PROCESS,
        'S' => self::STATUS_SUCCESS,
        'F' => self::STATUS_FAILED,
    ];

    public static function getStatusByShortStatus($shortStatus)
    {
        return self::$shortStatusAndStatusMap[$shortStatus] ?: null;
    }
}